﻿using System;
using System.Windows.Forms;

namespace AbstractFactoryPattern
{
    public partial class Client : Form
    {
        public Client()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //new design object of msdesign
            AbstractDesign design = new MsDesign();
            //wirte the choosen design into the textbox
            tbResult.AppendText("Theme MS-Design wurde ausgewählt\n");
            //returns the method createBackground product for msdesign
            AbstractBackground background = design.createBackground();
            //write the string into the textbox
            tbBackgroundActivitie.AppendText(background.changeBackground());
            //returns the method createScrollbar product for msdesign
            AbstractScrollbar scrollbar = design.createScrollbar();
            //write the string into the textbox
            tbBackgroundActivitie.AppendText(scrollbar.changeScrollbar());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //new design object of macdesign
            AbstractDesign design = new MacDesign();
            //wirte the choosen design into the textbox
            tbResult.AppendText("Theme Mac-Design wurde ausgewählt\n");
            //returns the method createBackground product for macdesign
            AbstractBackground background = design.createBackground();
            //write the string into the textbox
            tbBackgroundActivitie.AppendText(background.changeBackground());
            //returns the method createScrollbar product for macdesign
            AbstractScrollbar scrollbar = design.createScrollbar();
            //write the string into the textbox
            tbBackgroundActivitie.AppendText(scrollbar.changeScrollbar());
        }
    }
}
