﻿namespace ImplementationFactoryMethodPattern
{
    /// <summary>
    /// Declares the factory method
    /// </summary>
    public class Creator
    {
        /// <summary>
        /// Decide which class to instantiate
        /// </summary>
        public IProduct factoryMethod(char achar)
        {
            IProduct aIProduct = null;
            //The factory method decides on the basis 
            //of 'achar' which product class to instatiates.
            switch (achar)
            {
                //In case of 'achar' = a -> creates an instance of ProductA
                case 'a' :
                    aIProduct = new ProductA();
                    break;
                //In case of 'achar' = b -> creates an instance of ProductB
                case 'b' :
                    aIProduct = new ProductB();
                    break;
            }
            return aIProduct;
        }
    }
}
