﻿using System;

namespace ImplementationFactoryMethodPattern
{
    /// <summary>
    /// The client tests the implementation of the 
    /// factory method pattern
    /// </summary>
    public class Client
    {
        public static void Main(string[] args)
        {
            Creator c = new Creator();
            IProduct aIProduct = null;

            //Calls the FactoryMethod in the Creator class
            //The FactoryMethod creates a new instance of ProductA
            //and saves it in product.
            aIProduct = c.factoryMethod('a');
            //Calls the method Product in ProductA class
            //and print it on the console.
            Console.WriteLine(aIProduct.product());

            //Calls the FactoryMethod in the Creator class
            //The FactoryMethod creates a new instance of ProductB
            //and saves it in product.
            aIProduct = c.factoryMethod('b');
            //Calls the method Product in ProductB class
            //and print it on the console.
            Console.WriteLine(aIProduct.product());
        }
    }
}
