﻿
namespace ImplementationAbstractFactoryPattern.Controller
{
    /// <summary>
    /// The Client class. Interaction environment for the products.
    /// </summary>
    public class Client
    {
        //varable of abstractProductA and abstractProductB
        private AbstractProductA abstractProductA;
        private AbstractProductB abstractProductB;

        //Constructor
        public Client(AbstractFactory factory)
        {
            //declare the constructor for the real factory with the method
            //to create the product
            abstractProductA = factory.createProductA();
            abstractProductB = factory.createProductB();
        }

        //method to show interaction between the products
        public void run()
        {
            //productB(x) interacts with productA(x)
            abstractProductB.interact(abstractProductA);
        }

    }
}
